<?php

if (
    class_exists('PHP_CodeSniffer_Standards_AbstractScopeSniff', true) === false
) {
    throw new PHP_CodeSniffer_Exception(
    	'Class PHP_CodeSniffer_Standards_AbstractScopeSniff not found'
    );
}


class Maarch_Sniffs_Functions_MethodVisibilitySniff 
    extends PHP_CodeSniffer_Standards_AbstractScopeSniff
{

    public function __construct()
    {
        parent::__construct(
            array(T_CLASS, T_INTERFACE), 
            array(T_FUNCTION), 
            true
        );

    }//end __construct()

    protected function processTokenWithinScope(
        PHP_CodeSniffer_File $phpcsFile, $stackPtr, $currScope
    ) {
        $methodName = $phpcsFile->getDeclarationName($stackPtr);
        if ($methodName === null) {
            // Ignore closures.
            return;
        }
        $className = $phpcsFile->getDeclarationName($currScope);
        $errorData = array($className.'::'.$methodName);
        
        $methodProps    = $phpcsFile->getMethodProperties($stackPtr);
        $isScopeSpecified = $methodProps['scope_specified'];
        
        if ($isScopeSpecified === false) {
            $error = "Visibility for method %s must be explicitly declared.";
            $phpcsFile->addError($error, $stackPtr, 
            					 'NoVisibilityDeclared', $errorData);
        }

    }

    protected function processTokenOutsideScope(
        PHP_CodeSniffer_File $phpcsFile, $stackPtr
    ) {
        return;
    }


}